<?php

//Exit if access directly...
if( ! defined( 'ABSPATH' ) ) exit();

//check if class not exists
if( !class_exists( 'ShirteeConfig' ) ){
    /**
     * A class to define and retrive Shirtee products attributes
     * It will return's attributes based on selected language in admin
     */
    class ShirteeConfig
    {

        /**
         * Set the shirtee products attributes/taxonomy names based on language.
         * @access public
         * @since 2.4
         * @return array taxonomy/attribute names
         */
        public static function set_attributes(){
            return array(
                'de'		=> array(
                    'size'  => 'grösse',
                    'color' => 'farbe'
                ),
                'en'		=> array(
                    'size' 	=> 'size',
                    'color' => 'color'
                ),
                'da'		=> array(
                    'size' 	=> 'størrelse',
                    'color' => 'farve'
                ),
                'es'		=> array(
                    'size' 	=> 'tamaño',
                    'color' => 'color'
                ),
                'fi'		=> array(
                    'size' 	=> 'koko',
                    'color' => 'väri'
                ),
                'fr'		=> array(
                    'size' 	=> 'taille',
                    'color' => 'couleur'
                ),
                'it'		=> array(
                    'size' 	=> 'taglia',
                    'color' => 'colore'
                ),
                'nl'		=> array(
                    'size' 	=> 'grootte',
                    'color' => 'kleur'
                ),
                'nb'		=> array(
                    'size' 	=> 'størrelse',
                    'color' => 'farge'
                ),
                'pl'		=> array(
                    'size' 	=> 'rozmiar',
                    'color' => 'kolor'
                ),
                'pt'		=> array(
                    'size' 	=> 'tamanho',
                    'color' => 'cor'
                ),
                'sv'		=> array(
                    'size' 	=> 'storlek',
                    'color' => 'färg'
                ),
            );
        }

        /**
         * Shirtee products attributes/taxonomy based on selected language
         * @access public
         * @param string $lang
         * @see ShirteeConfig::set_attributes
         * @since 2.4
         * @return array taxonomy/attribute names
         */
        public static function get_attributes( $lang='de' ){
            $languages = ShirteeConfig::set_attributes();
            if( array_key_exists( $lang,$languages ) ):
                return $languages[$lang];
            else:
                return "Invalid language supplied...";
            endif;
        }
    }
}
?>