<?php
/**
 * Get Products from Shirtee Store.
 * PHP version >= 5
 * @category  ShirteeProducts
 * @package   ShirteeProductsImporter
 * @author    Shirtee Team <mail@shirtee.com>
 * @copyright 2019 Shirtee
 * @license   GTU www.gtu.in
 * @link      www.shirtee.com
 * @since     1.5
 */
set_time_limit(0);
$path      = getcwd();
$root_path = explode("/wp-content", $path);
require_once $root_path[0].'/wp-load.php';
require_once SHIRTEE_ROOT_DIR.'/includes/classes/class-shirtee-products-importer.php';

$shirtee_importer_obj = new SHIRTEE_IMPORTER();
$settings          = $shirtee_importer_obj->shirtee_settings(); 



if (!$shirtee_importer_obj->is_shirtee_plugin_activate() || !$shirtee_importer_obj->is_shirtee_required_plugin_activate()) {
    exit;
}

if ($shirtee_importer_obj->is_migrated() == 'no') {
    return false;
}

global $wpdb;
$limit               = isset($_GET['limit']) && !empty($_GET['limit']) ? $_GET['limit'] : 50;
$tbl_shirtee_product = "{$wpdb->prefix}shirtee_import_products";
$products            = $wpdb->get_results("SELECT product_mage_id FROM {$tbl_shirtee_product} WHERE `status` = 0 LIMIT {$limit}");

if (!empty($products)) {
    try {
        foreach ($products as $product) {
            $wpdb->update(
                $tbl_shirtee_product,
                array(
                    "status"          => 4
                ),
                array(
                    "product_mage_id" => $product->product_mage_id
                )
            );
        }
        $res_data = $shirtee_importer_obj->execute_curl($products, 'product_detail');
		       
        if ($res_data['status'] == 'success') {
            $product_details = $res_data['data'];
            // Store information of products
            if (isset($product_details['synced'])) {
                foreach ($product_details['synced'] as $product_id => $product_detail) {
                    if (isset($product_detail['product_data'])) {
                        $product_data    = $product_detail['product_data'];
                        
                      //  $product_data  = json_decode($product_data ,true);
                        
                        $product_options = isset($product_detail['product_options']) ? $product_detail['product_options'] : '';
                        $product_options_new = isset($product_detail['product_options_new']) ? $product_detail['product_options_new'] : '';//product_options_new
                        $product_images  = isset($product_detail['product_images']) ? $product_detail['product_images'] : '' ;
                        
                        $details         = unserialize($product_data);
						
                        $product_title   = $details['variable_name'];
                        $product_type    = $details['campaign_title'];
                        $product_sku     = $product_detail['product_sku'];
                        $product_price   = $details['price'];
						
						
                        $count = countVariation( json_decode($product_options_new,true),unserialize($product_images) ); //product_options_new						
                        $result = $wpdb->update(
                            $tbl_shirtee_product,
                            array(
                                "product_title"      => esc_sql($product_title),
                                "product_type"       => esc_sql($product_type),
                                "product_sku"        => $product_sku,
                                "product_price"      => $product_price,
                                "product_data"       => $product_data,
                                "product_attributes" => $product_options,
                            	"product_attributes_new" => $product_options_new,//product_options_new
                                "product_images"     => $product_images,
                                "product_variations" => $count,
                                "status"             => 1
                            ),
                            array(
                                "product_mage_id"    => $product_id,
                            )
                        );
                        
                        //dropshipper user schedule product
                        if( isset($settings['dropshipping']) && $settings['dropshipping'] == "yes" ){
                            $import_cron = "{$wpdb->prefix}shirtee_import_product_insert_cron";
							$proInsed   = $wpdb->get_row("SELECT * FROM {$import_cron} WHERE mage_id = {$product_id}");
							if (!empty($proInsed)) {								
								$wpdb->query("DELETE FROM {$import_cron} WHERE mage_id = {$product_id}");
							}
                            $WpProductID=0;
                            $prod_status="insert";
                            if(isset($settings['product_status'])){
                                $publish =$settings['product_status'];
                            }else{
                                 $publish =0;
                            }
                            
                            $query = $wpdb->insert(
                                $import_cron,
                                array(
                                    "mage_id"        => $product_id,
                                    "woo_id"         => $WpProductID,
                                    "product_status" => $prod_status,
                                    "publish"        => $publish,
                                    "created_at"     =>  current_time('mysql'),
                                    "updated_at"     =>  current_time('mysql'),
                                    "status"         => 1,
                                )
                            );
                            $mage_products[0]['product_id']  = $product_id;
                            $mage_products[0]['prod_status'] = "insert";
                            $mage_products[0]['woo_id']      = 0;
                            $mage_products[0]['url']         = '';
                            $data = array(
                                "mage_ids"  => $mage_products,
                            );
                            $response = $shirtee_importer_obj->execute_curl($data, "schedule_product");
                        }
                        //dropshipper user end
                        
                    } else {
                        $wpdb->update(
                            $tbl_shirtee_product,
                            array(
                                "status"          => 0
                            ),
                            array(
                                "product_mage_id" => $product_id,
                            )
                        );
                    }
                }
            }
            // Removed products from Shirtee
            if (isset($product_details['removed'])) {
                foreach ($product_details['removed'] as $product_id) {
                    $wpdb->update(
                        $tbl_shirtee_product,
                        array(
                            "status"          => 5
                        ),
                        array(
                            "product_mage_id" => $product_id,
                        )
                    );
                }
            }
            // In Progress to fetch product information
            if (isset($product_details['not_synced'])) {
                foreach ($product_details['not_synced'] as $product_id) {
                    $wpdb->update(
                        $tbl_shirtee_product,
                        array(
                            "status"          => 0
                        ),
                        array(
                            "product_mage_id" => $product_id,
                        )
                    );
                }
            }
        }
    } catch (EXCEPTION $e) {
        $shirtee_importer_obj->send_emails("<p>". $e->getMessage().".</p>", "Sync Products from Shirtee");
        return false;
    }
}