<?php
set_time_limit(0);
$path 	   = getcwd();
$root_path = explode( "/wp-content",$path );
require_once( $root_path[0]. '/wp-load.php' );
require_once( SHIRTEE_ROOT_DIR. '/includes/classes/class-shirtee-products-importer.php' );
if ( !SHIRTEE_IMPORTER::is_shirtee_plugin_activate() || !SHIRTEE_IMPORTER::is_shirtee_required_plugin_activate() ) exit;
if( !function_exists( 'curl_init' ) ):
	send_email( "<p>We founds that curl is not enabled in your side. Please contact side administrator to enable the service of curl.</p><p><strong>Site URL :: <a href='".site_url()."' target='_blank'>".get_option( "blogname" )."</a></strong></p>" );
	return false;
endif;

$shirtee_importer_obj = new SHIRTEE_IMPORTER();

global $wpdb;
$settings     = "{$wpdb->prefix}shirtee_import_settings";
$chk_migrate  = $shirtee_importer_obj->shirtee_settings('is_migrated');
/* if( $chk_migrate == 1 ){
    return false;
} */
$tbl_products = "{$wpdb->prefix}shirtee_import_products";
$tbl_schedule = "{$wpdb->prefix}shirtee_import_product_insert_cron";
$tbl_orders   = "{$wpdb->prefix}shirtee_import_woo_orders";

$products     = $wpdb->get_results("SELECT * FROM {$tbl_products}",ARRAY_A);
$schedule     = $wpdb->get_results("SELECT * FROM {$tbl_schedule}",ARRAY_A);
$orders       = $wpdb->get_results("SELECT * FROM {$tbl_orders}",ARRAY_A);

if(!empty($products)){
    for( $p=0;$p<count($products);$p++ ){
        if($products[$p]['product_woo_id'] != 0 || !empty($products[$p]['product_woo_id'])){
            $products[$p]['url'] = get_the_permalink($products[$p]['product_woo_id']);
            $products[$p]['shirtee_woo_status'] = 2;
        }
    }
}

$order_wp_data = array();
if(!empty($orders)){
    for($o=0;$o<count($orders);$o++){
        if(is_null(get_post($orders[$o]['woo_order_ID']))){
            continue;
        }

        $order 		= wc_get_order($orders[$o]['woo_order_ID']);
        $order_data = $order->get_data();
        
        $order_wp_data[$o]['info']['site_url'] 		 = site_url();
		$order_wp_data[$o]['info']['type'] 			 = SHIRTEE_APP;
        
        $order_wp_data[$o]['info']['order_woo_id']   = $order_data['id'];
        $order_wp_data[$o]['info']['order_email']    = $order_data['billing']['email'];
        $order_wp_data[$o]['info']['order_date']     = $order_data['date_created']->date('Y-m-d H:i:s');
        $order_wp_data[$o]['info']['order_price']    = $order_data['total'];
        $order_wp_data[$o]['info']['currency']       = $order_data['currency'];
        $order_wp_data[$o]['info']['status']         = $order_data['status'];
        $order_wp_data[$o]['info']['discount'] 	     = $order_data['discount_total'];
        $order_wp_data[$o]['info']['discount_tax']   = $order_data['discount_tax'];
        $order_wp_data[$o]['info']['total_tax']      = $order_data['total_tax'];
        $order_wp_data[$o]['info']['billing']        = $order_data['billing'];
        $order_wp_data[$o]['info']['shipping']       = $order_data['shipping'];
        $order_wp_data[$o]['info']['shirtee_id']     = $orders[$o]['woo_shirtee_id'];
        $order_wp_data[$o]['info']['process_status'] = $orders[$o]['status'];

        $items = $order->get_items();
        $p = 0;
        foreach($items as $item_id => $item){
            $options 	= $attribute = array();
            $sizeAttrID = $attrSizeID = $colorAttrID = $attrColorID = $size = $color = '';

            $variation_id = 0;
            $product_id = $item['product_id'];
            if(!empty($product_id)){
                $price = get_post_meta($product_id, '_regular_price', true);
                
                $product_sku = get_post_meta($product_id,'_sku',true);
                $order_wp_data[$o]['info']['items'][$p]['sku'] = $product_sku;

                if(function_exists('wc_get_product')){
                    if(wc_get_product($product_id)->is_type('variable')){
                        $variation_id  = $item['variation_id'];
                        $price         = get_post_meta($variation_id, '_regular_price', true);
                        $variation_sku = get_post_meta($variation_id, '_sku', true);
                        $variation_sku = str_replace("--", "__", $variation_sku);
                        $order_wp_data[$o]['info']['items'][$p]['sku'] = $variation_sku;
                    }
                }

                $qty = $item['quantity'];
                
                $order_wp_data[$o]['info']['items'][$p]['product_id']   = $product_id;
                $order_wp_data[$o]['info']['items'][$p]['product_name'] = $item['name'];
                $order_wp_data[$o]['info']['items'][$p]['qty'] 		    = $qty;
                $order_wp_data[$o]['info']['items'][$p]['item_price']   = !empty($price) ? $price : $item['total']/$qty;
                $order_wp_data[$o]['info']['items'][$p]['item_tax'] 	= $item['total_tax'] != '' ? $item['total_tax'] : '0.00';
                $order_wp_data[$o]['info']['items'][$p]['shipping_tax'] = $order_data['shipping_tax'] != '' ? $order_data['shipping_tax'] : '0.00';
                $order_wp_data[$o]['info']['items'][$p]['shipping_amt'] = $order_data['shipping_total'] != '' ? $order_data['shipping_total'] : '0.00';
                $p++;
            }
        }
    }
}

$data = array(
    'products'  => $products,
    'schedule'  => $schedule,
    'orders'    => $order_wp_data,
);

$res_data = $shirtee_importer_obj->execute_curl($data, 'migrate_data');
if($res_data['status'] == 'success'){
    if ($chk_migrate == 0) {
        $wpdb->update(
            $settings,
            array(
                "settings_value" => 1
            ),
            array(
                "settings_name"  => "is_migrated"
            )
        );
    } else {
        $wpdb->insert(
            $settings,
            array(
                "settings_name"  => "is_migrated",
                "settings_value" => 1
            )
        );
    }
}
?>