<?php
/**
 * Store order information and update
 * woo order status to "Completed"
 * 
 * PHP version >= 5
 * 
 * @category  ShirteeProducts
 * @package   ShirteeProductsImporter
 * @author    Shirtee Team <mail@shirtee.com>
 * @copyright 2019 Shirtee
 * @license   GTU www.gtu.in
 * @link      www.shirtee.com
 * @since     1.5
 */


set_time_limit(0);

if( !empty($_GET['user']) && !empty($_GET['pass']) ){
    $path      = getcwd();
    $root_path = explode("/wp-content", $path);
    require_once $root_path[0]. '/wp-load.php';
    require SHIRTEE_ROOT_DIR.'/includes/classes/class-shirtee-products-importer.php';

    $shirtee_importer_obj = new SHIRTEE_IMPORTER();
    global $wpdb;
    $setting =  $shirtee_importer_obj->shirtee_settings();

    $user = $_GET['user'];
    $pass = $_GET['pass'];
    $target = array($user, $pass);
    if(in_array( $user ,$setting) && in_array($pass, $setting)){
        if ( isset($_GET['order_id']) && isset($_GET['order_info']) && !empty($_GET['order_id']) ) {  
                $orderid = $_GET['order_id'];
                $order      = wc_get_order($orderid);
                $order_data = $order->get_data();
                
                $order_wp_data['info']['site_url']       = site_url();           
                
                $order_wp_data['info']['order_woo_id']   = $order_data['id'];
                $order_wp_data['info']['order_email']    = $order_data['billing']['email'];
                $order_wp_data['info']['order_date']     = $order_data['date_created']->date('Y-m-d H:i:s');
                $order_wp_data['info']['order_price']    = $order_data['total'];
                $order_wp_data['info']['currency']       = $order_data['currency'];
                $order_wp_data['info']['status']         = $order_data['status'];
                $order_wp_data['info']['discount']       = $order_data['discount_total'];
                $order_wp_data['info']['discount_tax']   = $order_data['discount_tax'];
                $order_wp_data['info']['total_tax']      = $order_data['total_tax'];
                $order_wp_data['info']['billing']        = $order_data['billing'];
                $order_wp_data['info']['shipping']       = $order_data['shipping'];
                $order_wp_data['info']['shirtee_id']     = $orders[$o]['woo_shirtee_id'];
                $order_wp_data['info']['process_status'] = $orders[$o]['status'];

                $items = $order->get_items();
                $p = 0;
                foreach($items as $item_id => $item){
                    $options    = $attribute = array();
                    $sizeAttrID = $attrSizeID = $colorAttrID = $attrColorID = $size = $color = '';

                    $variation_id = 0;
                    $product_id = $item['product_id'];
                    
                    $price = get_post_meta($product_id, '_regular_price', true);
                    
                    $product_sku = get_post_meta($product_id,'_sku',true);
                    $order_wp_data['info']['items'][$p]['sku'] = $product_sku;

                    if(function_exists('wc_get_product')){
                        if(wc_get_product($product_id)->is_type('variable')){
                            $variation_id  = $item['variation_id'];
                            $price         = get_post_meta($variation_id, '_regular_price', true);
                            $variation_sku = get_post_meta($variation_id, '_sku', true);
                            $variation_sku = str_replace("--", "__", $variation_sku);
                            $order_wp_data['info']['items'][$p]['sku'] = $variation_sku;
                        }
                    }

                    $qty = $item['quantity'];
                    
                    $order_wp_data['info']['items'][$p]['product_id']   = $product_id;
                    $order_wp_data['info']['items'][$p]['product_name'] = $item['name'];
                    $order_wp_data['info']['items'][$p]['qty']          = $qty;
                    $order_wp_data['info']['items'][$p]['item_price']   = !empty($price) ? $price : $item['total']/$qty;
                    $order_wp_data['info']['items'][$p]['item_tax']     = $item['total_tax'] != '' ? $item['total_tax'] : '0.00';
                    $order_wp_data['info']['items'][$p]['shipping_tax'] = $order_data['shipping_tax'] != '' ? $order_data['shipping_tax'] : '0.00';
                    $order_wp_data['info']['items'][$p]['shipping_amt'] = $order_data['shipping_total'] != '' ? $order_data['shipping_total'] : '0.00';
                    $p++;
                }
                echo "<pre>";
                print_r($order_wp_data);
                exit;
        }    


        if ( isset($_GET['order_id'])  && isset($_GET['status_change']) && !empty($_GET['order_id']) && ($_GET['status_change'] == 0) ) {           
            $orderid = $_GET['order_id'];
            $woo_orders = "{$wpdb->prefix}shirtee_import_woo_orders";
            $wpdb->update(
                $woo_orders,
                array(
                    "status"      => 0,           
                ),
                array(
                    "woo_order_ID"    => $orderid,            
                )
            );   
            echo "Changed status of ordre no:".$orderid;
            exit;
        }
        if ( isset($_GET['order_id'])  && isset($_GET['status_change']) && !empty($_GET['order_id']) && ($_GET['status_change'] == 1) && !empty($_GET['woo_shirtee_id']) ) {           
            $orderid = $_GET['order_id'];
            $woo_shirtee_id = $_GET['woo_shirtee_id'];
            $woo_orders = "{$wpdb->prefix}shirtee_import_woo_orders";
            $wpdb->update(
                $woo_orders,
                array(
                    "status"      => 1, 
                    "woo_shirtee_id"=>  $woo_shirtee_id        
                ),
                array(
                    "woo_order_ID"    => $orderid,            
                )
            );   
            echo "Added woo_shirtee_id of order no:".$orderid;
            exit;
        }
    }  else {
        echo "Please enter correct user and password";
    }  
} else {
    echo "Please enter user and password";
}
exit;
?>