<?php
/**
 * Process woo create product
 *
 * PHP version >= 5
 *
 * @category  ShirteeProducts
 * @package   ShirteeProductsImporter
 * @author    Shirtee Team <mail@shirtee.com>
 * @copyright 2020 Shirtee
 * @license   GTU www.gtu.in
 * @link      www.shirtee.com
 * @since     1.5
 */
set_time_limit(0);
$path      = getcwd();
$root_path = explode("/wp-content", $path);
require_once $root_path[0].'/wp-load.php';
require_once SHIRTEE_ROOT_DIR.'/includes/classes/class-shirtee-products-importer.php';
$shirtee_importer_obj = new SHIRTEE_IMPORTER();

if (!$shirtee_importer_obj->is_shirtee_plugin_activate() || !$shirtee_importer_obj->is_shirtee_required_plugin_activate()) {
    exit;
}
if ($shirtee_importer_obj->is_migrated() == 'no') {
    return false;
}
global $wpdb;
$import_cron        = "{$wpdb->prefix}shirtee_import_product_insert_cron";
$product_list       = "{$wpdb->prefix}shirtee_import_products";
$limit              = isset($_GET['limit']) && !empty($_GET['limit']) ? $_GET['limit'] : 3;
$settings          = $shirtee_importer_obj->shirtee_settings(); 
$woo_token          = $shirtee_importer_obj->shirtee_settings('woo_token'); //get woo token
$woo_token          = json_decode($woo_token,true);
$consumer_key       = $woo_token['consumer_key'];
$consumer_secret    = $woo_token['consumer_secret'];
$store_url          = home_url( '/' );
$newcondition       = '';

if (array_key_exists('pmageid', $_REQUEST)) 
{   
    if (!empty($_REQUEST['pmageid'])) 
    {
        //$limit = 1;
        $newcondition = "and mage_id='".$_REQUEST['pmageid']."'";
    }    
}

$products           = $wpdb->get_results("SELECT `ID`,`uid`,`mage_id`,`product_status`,`woo_id`,`publish`  FROM {$import_cron} WHERE status = 1 and product_status='insert' {$newcondition} LIMIT {$limit}");
if ( !empty($products) ) {
    try {        
        // if another cron job started
        foreach ($products as $product) {
            $wpdb->update(
                $import_cron,
                array(
                    "status"  => 4
                ),
                array(
                    "mage_id" => $product->mage_id
                )
            );
        }  
            
    if(isset($settings['product_status'])){
        $publish_status = $settings['product_status'];
     }else{
     $publish_status = 0;
    }  
        foreach( $products as $product ) {

            
            $product_id                     = $product->mage_id;             
            $cronID                         = $product->ID;
            $post_status                    = $publish_status;
            $publish                        = $post_status == 1 ? 'publish' : 'draft';//check product status             
            $callAPI                        = true;
            $images                         = '';
            $Pstatus                        = $product->product_status;
            $uid                            = $product->uid != '' ? $product->uid : 1;
            $insert_id                      = $product->woo_id != 0 ? $product->woo_id : '';
            $products_data                  = $wpdb->get_row("SELECT * FROM {$product_list} WHERE `product_mage_id` = {$product->mage_id} AND `status` = 1");
            //new API Data
            if ( empty($products_data) ) { //if product data empty then cron status 2
                $wpdb->update(
                    $import_cron,
                    array(
                        "status"  => 2
                    ),
                    array(
                        "mage_id" => $product->mage_id
                    )
                );
                continue;
            }
            $productData = array();       
            	
              if( $products_data->product_variations != 0 ){ //check if variaion avialable then product create 
                $pID                            = $products_data->ID;
            	if( $products_data->is_all_import == 1 || $products_data->is_warehouse == 1 )
                {
                    $result 					= json_decode($products_data->product_data,true);
                    $product_options                = json_decode($products_data->product_attributes,true);                    
                	$product_images                 = json_decode($products_data->product_images,true); 
                 } else {
                	$result                         = unserialize($products_data->product_data);  
                    if( !empty($products_data->product_attributes_new) ){
                        $product_options                = json_decode($products_data->product_attributes_new, true);                    
                    } else {
                        $product_options                = unserialize($products_data->product_attributes);                    
                    }
                	$product_images                 = unserialize($products_data->product_images);                          
                }           
               
                if( isset($result['ean_sku']) && (!empty($result['ean_sku'])) ){  //Check EAN Code in warehouse
                    $sku                            = $result['ean_sku'];
                } else {
                	$sku                            = $result['sku'];
                }
                $name                           = trim($result['campaign_title']); 
                $price                          = $result['price'];
                $regular_price                  = $result['price'];                        
                $description                    = $result['description'];
                  /* Meta Details*/
                $meta_title                     = $result['meta_title'];
                $meta_keyword                   = $result['meta_keyword'];
                $meta_description               = $result['meta_description'];

                $short_description              = "<ul>";
                $short_description              .= !empty($result['amazon_bulletpoint1']) ? "<li>{$result['amazon_bulletpoint1']}</li>" : "";
                $short_description              .= !empty($result['amazon_bulletpoint2']) ? "<li>{$result['amazon_bulletpoint2']}</li>" : "";
                $short_description              .= !empty($result['amazon_bulletpoint3']) ? "<li>{$result['amazon_bulletpoint3']}</li>" : "";
                $short_description              .= !empty($result['amazon_bulletpoint4']) ? "<li>{$result['amazon_bulletpoint4']}</li>" : "";
                $short_description              .= !empty($result['amazon_bulletpoint5']) ? "<li>{$result['amazon_bulletpoint5']}</li>" : "";
                $short_description              .= "</ul>";
                 
				$attribute                      = array_values($product_options );
				$type                           = "variable";
				/*if ( $products_data->product_variations == 1) { //check product simple or variation 
					$type = "simple";
				}*/   
            
                $result['options']              = $product_options;
                $result['images']               = $product_images;
                $optionsData = "";
                if( $type == "variable"){
                    $optionsData                = productAttributeCreate($result); // create product attribute
                }
                $img                            = array();
                $mainimge                       = array();
                $colorValue                     = array();                
                $i=0;
            	if( $products_data->is_all_import == 1 ){
                    foreach($product_images as $product_image){
                        $mainimge[$i]['src'] = $product_image['url'];						
                        $mainimge[$i]['name'] = $sku."-".$i;
                        $mainimge[$i]['alt'] = $name."-".$i;
                        $i++;
                    }
        		 } else {     
                    foreach( $attribute[1]['additional_fields'] as $colorvar ){
                        $colorValue[]               = $colorvar['value_id'];
                    }
					
                    foreach($product_images as $product_image){ //product image generate from url to shirtee 
                        if (in_array($product_image['label'], $colorValue)){
                            $url = $product_image['url'];
							$redirectedUrl = "";
							if( $products_data->is_warehouse == 1 ){
								$redirectedUrl = $url;
							} else {
                                $ch = curl_init(); 
                                curl_setopt($ch, CURLOPT_URL, $url); 
                                curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE); 
                                curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE); 
                                $html = curl_exec($ch); 
                                $redirectedUrl = curl_getinfo($ch, CURLINFO_EFFECTIVE_URL);                         
							}
                            $mainimge[$i]['src'] = $redirectedUrl;
                            $mainimge[$i]['name'] = $sku."-".$product_image['label'];
                            $mainimge[$i]['alt'] = $name."-".$product_image['label'];
                            $i++;
                        }                   
                    } 
        		}
				 
                $weight                             = $result['weight'];
                $length                             = $result['length'];
                $width                              = $result['width'];
                $height                             = $result['height'];
                $productData['name']                = $name;
                $productData['type']                = $type;
                $productData['price']               = "$price";
                $productData['regular_price']       = "$regular_price";
                $productData['description']         = $description;
                $productData['short_description']   = $short_description;
                $productData['sku']                 = $sku;
                $productData['attributes']          = $optionsData;
                
                $productData['manage_stock']        = false;
               	if( $products_data->is_all_import != 1 && $products_data->is_warehouse != 1 )
                {
                    $productData['manage_stock']        = true;
               		$productData['stock_quantity']      = "10000";
                }
                $productData['images']              = $mainimge;
                $productData['in_stock']            = true;
                $productData['weight']              = $weight;
                $productData['length']              = $length;
                $productData['width']               = $width;
                $productData['height']              = $height;
                $productData['status']              = $publish;             	
                          /* Meta Details*/
                $productData['meta_data'] = [[ 'key'=>'meta_title', 'value'=>$meta_title ], [ 'key'=>'meta_keyword', 'value'=>$meta_keyword ], [ 'key'=>'meta_description', 'value'=>$meta_description ] ];
                $productData                        = json_encode($productData); //product dat crearte json 
                $url                                = restApiUrl($store_url.'wp-json/wc/v3/products/',$consumer_key,$consumer_secret);
                $res_data                           = restApiCurlData($url, $productData);   
                  
                if( isset($res_data['data']['status']) && (isset($res_data['data']['status']) == 400) && (isset($res_data['data']['resource_id'])) ){
                    update_post_meta($res_data['data']['resource_id'], 'product_imported', 'yes');
                    if( isset($result['ean_sku']) && (!empty($result['ean_sku'])) ){ 
                        $wpdb->update(
                            $import_cron,
                            array('status' => 0, 'product_status' => 'update','woo_id' => $res_data['data']['resource_id']),
                            array('mage_id' => $product_id)
                        );
                        $wpdb->update(
                            $product_list,
                            array('product_woo_id' => $res_data['data']['resource_id']),
                            array('product_mage_id' => $product_id)
                        );
                        
                        
                        $data = array(
                            "product_mage_id" => $product_id,
                            "product_woo_url" => get_the_permalink($res_data['data']['resource_id']),
                            "product_woo_id"  => $res_data['data']['resource_id'],
                             "update_status"   => 1
                        );
                        $shirtee_importer_obj->execute_curl($data, "update_details");
                    } else {
                        $wpdb->update(
                            $import_cron,
                            array('status' => 1, 'product_status' => 'update','woo_id' => $res_data['data']['resource_id']),
                            array('mage_id' => $product_id)
                        );
                    }
                    continue;
                }
                if( !empty($res_data) && isset($res_data['id']) ){ //create product variation                     
                    $postid                         = $res_data['id'];
                    update_post_meta($postid, 'product_imported', 'yes');
                    if (isset($result['is_customize_product']) && ($result['is_customize_product'] == 1) ) {
                        update_post_meta($postid, 'is_customize', 1);
                    }
                    $images                         = $res_data['images'];                     
					$varData                        = array();
					$main                           = 0;     
					if ( $products_data->product_variations != 0) { //check product simple or variation 
						
                        $warehouse = 0;
                        if( $products_data->is_warehouse == 1 ){
                            $warehouse = 1;
                        }
                            
						if( $products_data->is_all_import == 1 ){
							$varData                        = createAlloverVariation($sku,$attribute,$product_images,$regular_price);
                        } else {							
							$varData                        = createVariation($sku,$attribute,$product_images,$regular_price,$warehouse);
						}
						
						//create variation
						$vartionData                    = array();                
						$vartionData['create']          = $varData;
						$vartionData                    = json_encode($vartionData);   
						$url                            = restApiUrl($store_url.'wp-json/wc/v3/products/'.$postid.'/variations/batch',$consumer_key,$consumer_secret);
						$res_data                       = restApiCurlData($url, $vartionData); 
					}    
                   // }
                    if(!empty($res_data) ){
                        $data = array(
                            "product_mage_id" => $product_id,
                            "product_woo_url" => get_the_permalink($postid),
                            "product_woo_id"  => $postid,
                        );
                        $res_data = $shirtee_importer_obj->execute_curl($data, "update_details"); //uddate product in shirtee cloud
                        
                        $productsData['sku']         = $sku;
                        $productsData['image_title'] = $products_data->product_type;
                        $productsData['images']      = $images;
                        $state                       = create_measure_image($productsData); //create masurement image
                        updateProductImages($postid,$sku,$images); //update in product                         
                        $wpdb->update(
                            $import_cron,
                            array('status' => 0, 'updated_at' => current_time('mysql'), 'woo_id'     => $postid ),
                            array('ID'         => $cronID)
                        );
                        $wpdb->update(
                            $product_list,
                            array('product_woo_id'  => $postid),
                            array('product_mage_id' => $product_id)
                        );
                    }
                } else {
                    $shirtee_importer_obj->send_emails("<p>Product ID :: ".$product->mage_id.".</p>", "Product not created in woo");
                }
            }
            //new API Data close
        }
    } catch (EXCEPTION $e) {
        $wpdb->update(
            $import_cron,
            array('status'     => 0, 'updated_at' => current_time('mysql')),
            array('ID' => $product->ID)
        );
        $shirtee_importer_obj->send_emails("<p>".$e->getMessage()."</p><p>Product ID :: ".$product->mage_id.".</p>", "Product not created in woo");
        return false;
    }
}