<?php

/**
 * Shirtee Products Importer Uninstall
 *
 * Uninstalling Shirtee Products Importer deletes tables and options.
 *
 * @package shirtee-products-1\Uninstaller
 * @since   3.10
 * @author  shirtee
 * @version 3.10
 */

defined('WP_UNINSTALL_PLUGIN') || exit;

include_once dirname(__FILE__) . '/includes/classes/class-shirtee-products-importer.php';
$shirtee_importer = new SHIRTEE_IMPORTER();
$res_data = $shirtee_importer->execute_curl("", "uninstall_data");
if ($res_data['status'] == "error") {
    return false;
}

global $wpdb;
$shirtee_products = "{$wpdb->prefix}shirtee_import_products";
$product_crons    = "{$wpdb->prefix}shirtee_import_product_insert_cron";
$shirtee_orders   = "{$wpdb->prefix}shirtee_import_woo_orders";
$shirtee_settings = "{$wpdb->prefix}shirtee_import_settings";
$wpdb->query("DROP TABLE {$shirtee_products}");
$wpdb->query("DROP TABLE {$product_crons}");
$wpdb->query("DROP TABLE {$shirtee_orders}");
$wpdb->query("DROP TABLE {$shirtee_settings}");

delete_option('shirtee_redirect_to_help');
delete_option('shirtee_db_version');
delete_option('shirtee_plugin_version');
delete_option('shirtee_popup_show');
